;;; -*- Mode: Lisp -*-
;;;
;;; ilogic/autosolve.l --- Ilust Logic for xyzzy

;;; Copyright (C) 2001 OHKUBO Hiroshi

;;; Author: OHKUBO Hiroshi
;;; Time-stamp: <2001/10/10 06:41:18 +0900>

;;; Code

(provide "ilogic/autosolve")

(in-package "ilogic")

;(eval-when (:compile-toplevel :load-toplevel :execute)
;  (require "ilogic/data"))

(defvar *buffer-autosolve* "I-Logic: AutoSolve")

(defvar *autosolve-mode-hook* nil)

(defvar *autosolve-map* nil)
(setq *autosolve-map* (make-sparse-keymap))

(defun set-autosolve-buffer ()
  (set-buffer (get-buffer-create *buffer-autosolve*))
  (autosolve-mode))

(defun autosolve-delete ()
  (interactive)
  (delete-buffer *buffer-autosolve*))

(defun autosolve-mode ()
  (setq buffer-mode 'ilogic-autosolve)
  (setq mode-name *mode-name*)
  (make-local-variable 'title-bar-format)
  (setq title-bar-format (format nil "~A - %b" *version-name*))
  (setq buffer-read-only t)
  (setq need-not-save t)
  (setq kept-undo-information nil)
  (setq auto-save nil)
  (toggle-ime nil)
  (set-local-window-flags (selected-buffer)
			  *window-flag-line-number* nil)
  (set-local-window-flags (selected-buffer)
			  *window-flag-newline* nil)
  (set-local-window-flags (selected-buffer)
			  *window-flag-eof* nil)
  (set-local-window-flags (selected-buffer)
			  *window-flag-cursor-line* nil)
  (set-buffer-fold-width nil)
  (use-keymap *autosolve-map*)
  (run-hooks '*autosolve-mode-hook*))

(defun autosolve-run (ilogicdata)
  (let ((buffer-read-only nil))
    (declare (special buffer-read-only))
    (erase-buffer (selected-buffer))
    (ilogic-solve (ilogicdata-input ilogicdata) nil nil)))


(defun autosolve-view-initial-matrix (ilogicdata)
  (let ((buffer-read-only nil)
	(indication (make-indication (ilogicdata-input ilogicdata))))
    (declare (special buffer-read-only))
    (erase-buffer (selected-buffer))
    (print-matrix-base indication nil nil))
    (set-buffer-modified-p nil)
  )
