;;; -*- Mode: Lisp -*-
;;;
;;; ilogic/data.l --- Ilust Logic for xyzzy

;;; Copyright (C) 2001 OHKUBO Hiroshi

;;; Author: OHKUBO Hiroshi
;;; Time-stamp: <2001/10/08 10:18:45 +0900>

;;; Code

(provide "ilogic/data")

(in-package "ilogic")

(defstruct autosolve
  date               ; 𓚓t
  difficulty         ; ՓxivZlċ߂j
  inconsistency      ; ɖ
  number-of-answers  ; ̌
  answerdatas
  )

(defstruct author
  name               ; O
  email              ; E-Mail
  url                ; URL
  )

(defstruct ilogicdata
  class                         ; ށitH_j
  title                         ; ^Cg
  problem                       ; 蕶
  level                         ; x ij
  comment                       ; Rg
  answer                        ; 𓚁ij
  input                         ; f[^
  width                         ; 
  height                        ; 
  date                          ; ͓t
  author                        ; ҏ
  autosolve                     ; 𓚂ɂ
  )

(defstruct answerdata
  matrix             ; 𓚃f[^
  row-check          ; s̃`FbN
  col-check          ; ̃`FbN
  supposition-depth  ; ̂ɕKvȉ̐[
  process            ; Ăo
  time               ; ̂ɂ
  )

(defun get-new-file-name (dir)
  (let (file-list
	file-name i)
    (unless (file-exist-p dir)
      (return-from get-new-file-name nil))
    (setq file-list (directory dir :file-only t :wild "*.dat"))
    (delete "./" file-list :test #'string=)
    (setq file-list (sort file-list #'string<))

    (setq i 0)
    (loop
      (incf i)
      (setq file-name (concat (format nil "~8,'0D" i) ".dat"))
      (unless (find file-name file-list :test #'string-equal)
	(return)))
    file-name))
