;;; -*- Mode: Lisp -*-
;;;
;;; ilogic/etc.l --- Ilust Logic for xyzzy

;;; Copyright (C) 2001 OHKUBO Hiroshi

;;; Author: OHKUBO Hiroshi
;;; Time-stamp: <2001/10/10 07:29:08 +0900>

;;; Code

(provide "ilogic/etc")

(in-package "ilogic")

;(eval-when (:compile-toplevel :load-toplevel :execute)
;  (require "ilogic/data"))

(defun clear-undo-information ()
  (let ((kept-undo-information nil))
    (declare (special kept-undo-information))
    (insert #\a)
    (delete-region (point) (1- (point)))))

(defun file-backup (file)
  (when (file-exist-p file)
    (copy-file file (concat file ".bak")
	       :if-exists :overwrite)))

(defun delete-unsuitable-filename-char (file-name)
  (let ((str file-name))
    (delete #\\ str)
;    (delete #\/ str)
    (delete #\: str)
    (delete #\, str)
    (delete #\; str)
    (delete #\* str)
    (delete #\? str)
    (delete #\" str)
    (delete #\< str)
    (delete #\> str)
    (delete #\| str)
    str))
    
(defun shuffle-list (list)
  (let (return-list
	(copy (copy-list list))
	tmp
	i)
    (while copy
      (setq i (random (length copy)))
      (if (zerop i)
	  (push (pop copy) return-list)
	(progn
	  (setq tmp copy)
	  (dotimes (j (1- i))
	    (setq tmp (cdr tmp)))
	  (push (pop (cdr tmp)) return-list))))
    return-list))

(defun join-string-list (join str-list)
  (let ((return-str "") (cnt (length str-list)))
    (dolist (str str-list)
      (incf cnt -1)
      (when (stringp str)
	(setq return-str (concat return-str str (if (> cnt 0) join "")))))
    return-str))
