;;; -*- Mode: Lisp -*-
;;;
;;; ilogic/makefile.l --- Ilust Logic for xyzzy

;;; Copyright (C) 2001 OHKUBO Hiroshi

;;; Author: OHKUBO Hiroshi
;;; Time-stamp: <2001/10/10 08:11:45 +0900>

;;; Code

(provide "ilogic/makefile")

(defvar *ilogic-file-list* '("main.l"
;			     "data.l"
			     "method.l"
			     "input.l"
			     "draw.l"
			     "menu.l"
			     "etc.l"
			     "infoinput.l"
			     "select.l"
			     "infoupdate.l"
			     "autosolve.l"
			     "popup.l"
			     "convert.l"
			     ))

(defvar *ilogic-root-directory*
  (merge-pathnames "site-lisp/ilogic" (si:system-root)))

(defvar *ilogic-buffer-make* "ilogic: MAKE")

(defun ilogic-make ()
  (interactive)
  (let ((files *ilogic-file-list*)
	(path *ilogic-root-directory*))
    (dolist (f files)
      (let ((file (merge-pathnames f path))
	    (filec))
	(setq filec (concat file "c"))
	(if (file-newer-than-file-p file filec)
	    (byte-compile-file file)
	  (message "skipping file: ~A" file))))))

(defun ilogic-make-tags-file ()
  (interactive)
  (let ((path *ilogic-root-directory*))
    (set-default-directory path)
    (make-tags-file path)))

(defun ilogic-make-all ()
  (interactive)
  (ilogic-make)
  (ilogic-make-tags-file))

(defun ilogic-make-clean ()
  (interactive)
  (let ((path *ilogic-root-directory*))
    (set-default-directory path)
    (dolist (f (directory path))
      (when (or (string-match "~$" f)
		(string-match "\.lc" f)
		(string-matchp "xtags" f))
	(delete-file f)
	(message "File deleted: ~A" f)))))
