;;; -*- Mode: Lisp -*-
;;;
;;; ilogic/method.l --- Ilust Logic for xyzzy

;;; Copyright (C) 2001 OHKUBO Hiroshi

;;; Author: OHKUBO Hiroshi
;;; Time-stamp: <2001/10/05 08:40:15 +0900>

;;; changes
;;;

;;; todo
;;;
;;; EO킩ȂȂ̂邽߂ setq 炯ǁA
;;;   ǂ킯킩ȂȂāA񂴂肷̂ŁAdefstruct 
;;;   ƍ\̂`Ĉꂩ珑ȂB

;;; EJ[WbNΉ

;;; Code

; ----------------------------------------------------------------------

(provide "ilogic/method")

(in-package "ilogic")

(defvar *ilogic-attribute-alist*
  (list
   '(new                   . (:foreground 1 :bold t))
   '(pre-supposition       . (:foreground 0 :background 4))
   '(pre-supposition-basis . (:foreground 2 :background 11 :bold t))
   '(supposition           . (:foreground 0 :background 1))
   '(supposition-basis     . (:foreground 3 :background 13 :bold t))))


(defvar *row-check-time* 0)
(defvar *col-check-time* 0)
(defvar *max-supposition-level* 0)

(defun ilogic-solve (input &optional (matrix-only nil) (interval-time nil))
  ;; ϐ̏
  (setq *row-check-time* 0)
  (setq *col-check-time* 0)
  (setq *max-supposition-level* 0)
      
  (save-excursion
    (let (indication
	  matrix-simple-info
	  start-point
	  return-value)

      (setq start-point (point))

      (setq indication (make-indication input))
      (setq matrix-simple-info (make-matrix-simple-info input))
      (setq update-info (make-update-info input))
      
      (print-matrix-base indication matrix-simple-info matrix-only)

      (setq return-value
	    (ilogic-solve-supposition indication matrix-simple-info update-info
				      0 matrix-only interval-time))
      (case return-value
	((:error)
	 (message-box "܂B"))
	((nil)
	 (message-box "rŉȂȂ܂B"))
	(t
	 (delete-region (point) (point-max))
	 (setq return-value (reverse return-value))
	 (dotimes (i (length return-value))
	   (print-matrix-base indication (nth i return-value) matrix-only)
	   (when (< (1+ i) (length return-value))
	     (goto-char (point-max))
;	     (insert "\n")
	     (insert "-" 70)
	     (insert "\n")))
	 (message-box (format nil "I܂B\n𓚂 ~S ŁA\n𓚋yщ𓚐`FbNɗvő剼背x ~D łB"
			      (length return-value) *max-supposition-level*))
	 ))
      )))


;;         𓚂ɐ matrix-simple-info ̃Xg answer-matrix-simple-info-list
;; Ȃ  nil
;;       :error
(defun ilogic-solve-supposition (indication matrix-simple-info update-info supposition-level
  			         &optional (matrix-only nil) (interval-time 0.1))
  (let (return-value
	answer-matrix-simple-info-list
	undecided-cell-list
	undecided-cell
	update-undecided-cell
	finish-undecided-cell-list
	(supposition-update nil))
    (while t
      (setq return-value (ilogic-solve-certainty indication matrix-simple-info update-info
						 supposition-level
						 matrix-only interval-time))
      (case return-value
	((:error) ; 
	 (return-from ilogic-solve-supposition :error))
	((nil)	  ; rŒ~
	 nil)
	(t	  ; 𓚐
	 (return-from ilogic-solve-supposition (list matrix-simple-info)))
	)
      
      (setq undecided-cell-list (make-undecided-cell-list matrix-simple-info))
      ;; iȂƂȂjVbt
;      (setq undecided-cell-list (shuffle-list undecided-cell-list))
      ;; 肪łȏԂɃ\[g
      (setq undecided-cell-list
	    (priority-consideration-sort-undecided-cell-list undecided-cell-list finish-undecided-cell-list))
      (setq finish-undecided-cell-list nil)
      (setq supposition-update nil)

      (while undecided-cell-list
	(setq undecided-cell (pop undecided-cell-list))
	(push undecided-cell finish-undecided-cell-list)

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;; "" ɉ
	(setq return-value
	      (ilogic-solve-supposition-1 undecided-cell 1
					  indication matrix-simple-info update-info
					  supposition-level nil
					  matrix-only interval-time))
	(case return-value
	  ((:error) ; 
	   (set-cell-simple-info matrix-simple-info undecided-cell (list 0 0 t))
	   (set-cell-update-info update-info undecided-cell)
	   (setq update-undecided-cell undecided-cell)
	   (setq supposition-update t)
	   (return))
	  ((nil)    ; rŒ~
	   nil)
	  ; 𓚐
	  (t
	   (push return-value answer-matrix-simple-info-list)
	   (setq return-value
		 (ilogic-solve-supposition-1 undecided-cell 0
					     indication matrix-simple-info update-info
					     supposition-level t
					     matrix-only interval-time))
	   (case return-value
	     ((:error)
	      nil)
	     ((nil)
	      nil)
	     (t
	      (setq answer-matrix-simple-info-list
		    (append return-value answer-matrix-simple-info-list))
	      ))
	   (return-from ilogic-solve-supposition answer-matrix-simple-info-list)
	   )
	  )

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;; "~" ɉ
	(setq return-value
	      (ilogic-solve-supposition-1 undecided-cell 0
					  indication matrix-simple-info update-info
					  supposition-level nil
					  matrix-only interval-time))
	(case return-value
	  ((:error) ; 
	   (set-cell-simple-info matrix-simple-info undecided-cell (list 1 0 t))
	   (set-cell-update-info update-info undecided-cell)
	   (setq update-undecided-cell undecided-cell)
	   (setq supposition-update t)
	   (return))
	  ((nil)    ; rŒ~
	   nil)
	  ; 𓚐
	  (t
	   (push return-value answer-matrix-simple-info-list)
	   (setq return-value
		 (ilogic-solve-supposition-1 undecided-cell 1
					     indication matrix-simple-info update-info
					     supposition-level t
					     matrix-only interval-time))
	   (case return-value
	     ((:error)
	      nil)
	     ((nil)
	      nil)
	     (t
	      (setq answer-matrix-simple-info-list
		    (append return-value answer-matrix-simple-info-list))
	      ))
	   (return-from ilogic-solve-supposition answer-matrix-simple-info-list)
	   )
	  )

	)
      
      ;; 1 iK̉ł͉𓚕s\̏ꍇ
      (unless supposition-update
	(setq undecided-cell-list (make-undecided-cell-list matrix-simple-info))
	;; x_ɑIԂȂ
;	(setq undecided-cell (nth (random (length undecided-cell-list)) undecided-cell-list))
	(setq undecided-cell-list
	      (priority-consideration-sort-undecided-cell-list undecided-cell-list nil))
	;; undecided-cell-list  undecided-cell PI
	(setq undecided-cell (car undecided-cell-list))

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;; ""
	(setq return-value
	      (ilogic-solve-supposition-1 undecided-cell 1
					  indication matrix-simple-info update-info
					  supposition-level t
					  matrix-only interval-time))

	(case return-value
	  ((:error)
	   nil)
	  ((nil)
	   nil)
	  (t
	   (setq answer-matrix-simple-info-list
		 (append return-value answer-matrix-simple-info-list))))

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;; "~"
	(setq return-value
	      (ilogic-solve-supposition-1 undecided-cell 0
					  indication matrix-simple-info update-info
					  supposition-level t
					  matrix-only interval-time))
	(case return-value
	  ((:error)
	   nil)
	  ((nil)
	   nil)
	  (t
	   (setq answer-matrix-simple-info-list
		 (append return-value answer-matrix-simple-info-list))))
	  
 	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	(return-from ilogic-solve-supposition answer-matrix-simple-info-list)

	)
      )
    ))

;; use-supposition  nil ̂Ƃ́A matrix-simple-info 
;; use-supposition  t   ̂Ƃ́Amatrix-simple-info-list ԂĂ
;; ςȊ֐ƂȂĂ̂Ōォ璼
(defun ilogic-solve-supposition-1 (cell
				   output indication matrix-simple-info update-info
				   supposition-level use-supposition
				   &optional (matrix-only nil) (interval-time 0.1))
  (setq *max-supposition-level*
	(max *max-supposition-level* (1+ supposition-level)))
  (message "@x ~D gp܂B" (1+ supposition-level))

  (save-excursion
    (let (return-value
	  tmp-indication
	  tmp-matrix-simple-info
	  tmp-update-info
	  pre-supposition-cell-list
	  pre-supposition-basis-cell-list
	  undecided-cell-list)
      (setq tmp-indication (copy-indication indication))
      (setq tmp-matrix-simple-info (copy-matrix-simple-info matrix-simple-info))
      (set-cell-simple-info tmp-matrix-simple-info cell (list output 0 t))
      (setq tmp-update-info (make-update-info tmp-indication nil))
      (set-cell-update-info tmp-update-info cell)

      (setq pre-supposition-cell-list
	    (get-cell-list-attribute 'supposition tmp-indication matrix-only))
      (setq pre-supposition-basis-cell-list
	    (get-cell-list-attribute 'supposition-basis tmp-indication matrix-only))
      (set-cell-list-attribute 'pre-supposition pre-supposition-cell-list
			       tmp-indication matrix-only)
      (set-cell-list-attribute 'pre-supposition-basis pre-supposition-basis-cell-list
			       tmp-indication matrix-only)
      
      (setq undecided-cell-list (make-undecided-cell-list tmp-matrix-simple-info))
      (set-cell-list-attribute 'supposition-basis (list cell) tmp-indication matrix-only)

      (setq return-value
	    (if use-supposition
		(ilogic-solve-supposition tmp-indication
					  tmp-matrix-simple-info
					  tmp-update-info
					  (1+ supposition-level)
					  matrix-only
					  interval-time)
	      (ilogic-solve-certainty tmp-indication
				      tmp-matrix-simple-info
				      tmp-update-info
				      (1+ supposition-level)
				      matrix-only
				      interval-time)))

      (unless (or (eq return-value :error) (eq return-value nil))
	(message "𓚂̂Pł")
;	(sleep-for 2)
	)

      (unset-cell-list-attribute 'supposition-basis (list cell) tmp-indication matrix-only)
      (clean-supposition-matrix (push cell undecided-cell-list) tmp-indication matrix-only)
      (set-cell-list-attribute 'supposition pre-supposition-cell-list
			       tmp-indication matrix-only)
      (set-cell-list-attribute 'supposition-basis pre-supposition-basis-cell-list
			       tmp-indication matrix-only)

      
      return-value)))


;;;;;;;;;;;;;;;;;;;;;;;;;;
;; I     matrix-simple-info
;; rŎ~܂ꍇ nil
;; ꍇ   :error
(defun ilogic-solve-certainty (indication matrix-simple-info update-info supposition-level
			       &optional (matrix-only nil) (interval-time 0.1))
  (save-excursion
    (let ((find-inconsistency nil)
	  left-indication upper-indication
	  row-simple-info col-simple-info
	  row-update-info col-update-info
          row-num col-num
	  update-flag
	  height width
	  start-point
	  last-line-check)
      (setq start-point (point))
      (setq height (length (car indication)))
      (setq width (length (cadr indication)))

      (setq left-indication (car indication))
      (setq upper-indication (cadr indication))
      
      (setq row-simple-info (car matrix-simple-info))
      (setq col-simple-info (cadr matrix-simple-info))

      (setq row-update-info (car update-info))
      (setq col-update-info (cadr update-info))
      
      (while (or (eval (cons 'or row-update-info))
		 (eval (cons 'or col-update-info)))
	; s̍XV
	(dotimes (i height)
	  (setq last-line-check
		(and (nth i row-update-info)
		     (some #'null (mapcar #'(lambda (cell-simple-info)
					      (nth 0 cell-simple-info))
					  (nth i row-simple-info)))))
	  (when (nth i row-update-info)
	    (setf (nth i row-update-info) nil)
	    (incf *row-check-time*)
	    ;--
;	    (debug-print "<row ~2D> :start: --\n" i)
	    ;--
	    (goto-char (point-max))
	    (previous-line)
	    (delete-region (progn (goto-bol) (point)) (progn (goto-eol) (point)))
	    (insert (format nil "update: ~D ~D" *row-check-time* *col-check-time*))
	    ;--
	    (if (null (update-matrix-line (nth i left-indication)
					  (nth i row-simple-info)
					  col-update-info))
		(setq find-inconsistency t))
	    ;--
;	    (debug-print
;	     (concat
;	      (format nil "~S\n" (nth i left-indication))
;	      (assistant-info-string (nth i left-indication)
;				     (nth i row-simple-info))))
;	    (debug-print "<row ~2D> :end: --------------------------------------------------\n" i)
	    ;--
	    (rotate-cell-update (nth i row-simple-info))
	    ;--
	    (goto-char start-point)
	    (overwrite-row-line (1+ i) row-simple-info indication
				supposition-level
				matrix-only interval-time)
	    (if last-line-check	    ;; ŏI`FbNÏR[hɓ
		nil)
	    ;--
	    (if find-inconsistency
		(return-from ilogic-solve-certainty :error))
	    ))
	; ̍XV
	(dotimes (i width)
	  (setq last-line-check
		(and (nth i col-update-info)
		     (some #'null (mapcar #'(lambda (cell-simple-info)
					      (nth 0 cell-simple-info))
					  (nth i col-simple-info)))))
	  (when (nth i col-update-info)
	    (setf (nth i col-update-info) nil)
	    (incf *col-check-time*)
	    ;--
;	    (debug-print "<col ~2D> :start: --\n" i)
	    ;--
	    (goto-char (point-max))
	    (previous-line)
	    (delete-region (progn (goto-bol) (point)) (progn (goto-eol) (point)))
	    (insert (format nil "update: ~D ~D" *row-check-time* *col-check-time*))
	    ;--
	    (if (null (update-matrix-line (nth i upper-indication)
					  (nth i col-simple-info)
					  row-update-info))
		(setq find-inconsistency t))
	    ;--
;	    (debug-print
;	     (concat
;	      (format nil "~S\n" (nth i upper-indication))
;	      (assistant-info-string (nth i upper-indication)
;				     (nth i col-simple-info))))
;	    (debug-print "<col ~2D> :end: --------------------------------------------------\n" i)
	    ;--
	    (rotate-cell-update (nth i col-simple-info))
	    ;--
	    (goto-char start-point)
	    (overwrite-col-line (1+ i) col-simple-info indication
				supposition-level
				matrix-only interval-time)
	    (if last-line-check	    ;; ŏI`FbNÏR[hɓ
		nil)
	    ;--
	    (if find-inconsistency
		(return-from ilogic-solve-certainty :error))
	    ))
	)

      (dolist (line-simple-info row-simple-info)
	(dolist (cell-simple-info line-simple-info)
	  (if (null (nth 0 cell-simple-info))
	      (return-from ilogic-solve-certainty nil))))
      matrix-simple-info)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ꂽꍇ nil
;; XV             1
;; XVȂ             0
(defun update-matrix-line (line-indication line-simple-info line-update-info)
  (let ((return-update 0)
	(next-flag t))
    (while next-flag
      (setq next-flag nil)
      (case (divide-potential-range line-indication line-simple-info)
	((nil)
	 (return-from update-matrix-line nil))
	((1)
	 (setq next-flag t)
	 (setq return-update 1)))
;      (debug-print (concat (format nil "divide-potential-range\n~S\n" line-indication)
;			   (assistant-info-string line-indication line-simple-info)))
      (case (delete-potential-range line-indication)
	((nil)
	 (return-from update-matrix-line nil))
	((1)
	 (setq next-flag t)
	 (setq return-update 1)))
;      (debug-print (concat (format nil "delete-potential-range\n~S\n" line-indication)
;			   (assistant-info-string line-indication line-simple-info)))
      (case (limit-potential-range line-indication line-simple-info)
	((nil)
	 (return-from update-matrix-line nil))
	((1)
	 (setq next-flag t)
	 (setq return-update 1)))
;      (debug-print (concat (format nil "limit-potential-range\n~S\n" line-indication)
;			   (assistant-info-string line-indication line-simple-info)))
      (case (set-determination-range line-indication line-simple-info)
	((nil)
	 (return-from update-matrix-line nil))
	((1)
	 (setq next-flag t)
	 (setq return-update 1)))
;      (debug-print (concat (format nil "set-determination-range\n~S\n" line-indication)
;			   (assistant-info-string line-indication line-simple-info)))
      (case (set-matrix-line line-indication line-simple-info line-update-info)
	((nil)
	 (return-from update-matrix-line nil))
	((1)
	 (setq next-flag t)
	 (setq return-update 1)))
;      (debug-print (concat (format nil "set-matrix-line\n~S\n" line-indication)
;			   (assistant-info-string line-indication line-simple-info)))

      )
    return-update))

;;   nil
;; XV    1
;; XVȂ    0
(defun divide-potential-range (line-indication line-simple-info)
  (let ((return-update 0)
	width cell-simple-info
        potential-cell-ranges range
        head tail)
    (setq width (length line-simple-info))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; "~" ܂ potential-cell-range 𕪊
    (dotimes (i width)
      (setq cell-simple-info (nth i line-simple-info))
      (when (and (nth 1 cell-simple-info)
		 (eq 0 (nth 0 cell-simple-info)))
	(dolist (one-indication line-indication)
	  (setq potential-cell-ranges (nth 2 one-indication))
	  (while potential-cell-ranges
	    (if (in-range i (car potential-cell-ranges))
  		(progn
		  (setq return-update 1)
  		  (setq head (cons (caar potential-cell-ranges) (1- i)))
  		  (setq tail (cons (1+ i) (cdar potential-cell-ranges)))
 		  (setf (car potential-cell-ranges) head)
  		  (push tail (cdr potential-cell-ranges))
  		  (setq potential-cell-ranges (cddr potential-cell-ranges)))
  	      (setq potential-cell-ranges (cdr potential-cell-ranges))))
	  )))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; A ""  range Ƃ܂މ\̂ index ̃Xg̎擾
    (let (on-range-info on-range range-stop potential-indexes
	  on-range-begin on-range-end
	  one-indication len determination-cell-range potential-cell-ranges)
      (setq on-range-info (get-on-range-info line-indication line-simple-info))
      (if (error-on-range-exist-p on-range-info)
	  (return-from divide-potential-range nil))
      
      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;; length  "..." ͈̔͂ potential-cell-range 
      ;; ܂܂ĂꍇApotential-cell-range u͈̔+OP}Xv
      ;; ͈͂ɕB
      (dolist (one-on-range-info on-range-info)
	(setq on-range (nth 0 one-on-range-info))
	(setq potential-indexes (nth 2 one-on-range-info))
	(setq on-range-begin (car on-range))
	(setq on-range-end (cdr on-range))
	(dolist (index potential-indexes)
	  (setq one-indication (nth index line-indication))
	  (setq len (nth 0 one-indication))
	  (setq potential-cell-ranges (nth 2 one-indication))
	  (when (< len (length-range on-range))
	    (while potential-cell-ranges
	      (if (in-range on-range (car potential-cell-ranges))
		  (progn
		    (setq return-update 1)
		    (setq head (cons (caar potential-cell-ranges) (- on-range-begin 2)))
		    (setq tail (cons (+ on-range-end 2) (cdar potential-cell-ranges)))
		    (setf (car potential-cell-ranges) head)
		    (push tail (cdr potential-cell-ranges))
		    (return))
		(setq potential-cell-ranges (cdr potential-cell-ranges)))))))

      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;; length Ɠ "..." ͈̔͂ potential-cell-range 
      ;; ܂܂ĂꍇApotential-cell-range  "..." ̑Oŕ
      (dolist (one-on-range-info on-range-info)
	(setq on-range (nth 0 one-on-range-info))
	(setq potential-indexes (nth 2 one-on-range-info))
	(setq on-range-begin (car on-range))
	(setq on-range-end (cdr on-range))

	(dolist (index potential-indexes)
	  (setq one-indication (nth index line-indication))
 	  (setq len (nth 0 one-indication))
	  (setq potential-cell-ranges (nth 2 one-indication))
	  (when (= len (length-range on-range))
	    (while potential-cell-ranges
	      (if (in-range on-range (car potential-cell-ranges))
		  (cond
		   ((and (not (in-range (1- on-range-begin) (car potential-cell-ranges)))
			 (not (in-range (1+ on-range-end) (car potential-cell-ranges))))
		    (return))
		   (t
		    (setq return-update 1)
		    (setq head (cons (caar potential-cell-ranges) (- on-range-begin 2)))
		    (setq tail (cons (+ on-range-end 2) (cdar potential-cell-ranges)))
		    (setf (car potential-cell-ranges) head)
		    (push tail (cdr potential-cell-ranges))
		    (push (copy-tree on-range) (cdr potential-cell-ranges))
		    (return)))
		(setq potential-cell-ranges (cdr potential-cell-ranges)))))))
      
      )
    
    return-update))

;;   nil
;; XV    1
;; XVȂ    0
(defun limit-potential-range (line-indication line-simple-info)
  (let ((return-update 0)
	begin-min end-max begin end len width indication-length
	determination-cell-range potential-cell-ranges)

    (setq width (length line-simple-info))
    (setq indication-length (length line-indication))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; ׂ potential-cell-ranges  length 
    ;; potential-cell-ranges ͈̔͂k
    (setq begin-min 0)
    (dolist (one-indication line-indication)
      (setq len (nth 0 one-indication))
      (setq potential-cell-ranges (nth 2 one-indication))
      (dolist (potential-cell-range potential-cell-ranges)
	(when (> begin-min (car potential-cell-range))
	  (setq return-update 1)
	  (setf (car potential-cell-range) begin-min)))
      (setq begin-min (+ (car (first potential-cell-ranges)) len 1)))
    (setq end-max (1- width))
    (dolist (one-indication (reverse line-indication))
      (setq len (nth 0 one-indication))
      (setq potential-cell-ranges (nth 2 one-indication))
      (dolist (potential-cell-range (reverse potential-cell-ranges))
	(when (< end-max (cdr potential-cell-range))
	  (setq return-update 1)
	  (setf (cdr potential-cell-range) end-max)))
      (setq end-max (- (cdar (last potential-cell-ranges)) len 1)))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; determination-cell-range  length 
    ;; potential-cell-ranges ͈̔͂k
    (dolist (one-indication line-indication)
      (setq len (nth 0 one-indication))
      (setq determination-cell-range (nth 1 one-indication))
      (setq potential-cell-ranges (nth 2 one-indication))
      (when (and determination-cell-range
		 (= 1 (length potential-cell-ranges)))
	(setq begin-min (- (cdr determination-cell-range) (1- len)))
	(when (> begin-min (caar potential-cell-ranges))
	  (setq return-update 1)
	  (setf (caar potential-cell-ranges) begin-min))

	(setq end-max (+ (car determination-cell-range) (1- len)))
	(when (< end-max (cdar potential-cell-ranges))
	  (setq return-update 1)
	  (setf (cdar potential-cell-ranges) end-max))))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; A ""  range Ƃ܂މ\̂ index ̃Xg̎擾
    (let (on-range-info on-range range-stop potential-indexes
	  on-range-begin on-range-end one-on-range-info on-range-info-length
	  one-indication)
      (setq on-range-info (get-on-range-info line-indication line-simple-info))
      (if (error-on-range-exist-p on-range-info)
	  (return-from limit-potential-range nil))
      (setq on-range-info-length (length on-range-info))

      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;; "..." ͈̔͂ potential-cell-ranges ɐڂĂA
      ;; ꕔ̂݊܂܂ĂꍇA͈̔͂܂܂Ȃ悤
      ;; potential-cell-ranges ߂
      (dolist (one-on-range-info on-range-info)
	(setq on-range (nth 0 one-on-range-info))
	(setq on-range-begin (car on-range))
	(setq on-range-end (cdr on-range))
	(dolist (one-indication line-indication)
	  (setq potential-cell-ranges (nth 2 one-indication))
	  (dolist (potential-cell-range potential-cell-ranges)
	    (cond
	     ((and (not (in-range on-range-end potential-cell-range))
		   (or (in-range on-range-begin potential-cell-range)
		       (= on-range-begin (1+ (cdr potential-cell-range)))))
	      (setq return-update 1)
	      (setf (cdr potential-cell-range) (- on-range-begin 2))
	      (return))
	     ((and (not (in-range on-range-begin potential-cell-range))
		   (or (in-range on-range-end potential-cell-range)
		       (= on-range-end (1- (car potential-cell-range)))))
	      (setq return-update 1)
	      (setf (car potential-cell-range) (+ on-range-end 2))
	      (return)))
	    )))

      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;; (m蕔܂Ȃꍇ)
      ;;  index  indication ̉\͈̔͂̒ "" ݂A
      ;;  "" ܂މ\̂ index Q̒őO or ォ璲ׂ
      ;;  index ԏ߂ꍇA index  indication 
      ;; \͈̔͂A "" ܂ݓȂuc̕v폜B

      ;; ȂɂĂ񂾂킯킩Ȃ̂ŁA}Ŋo

      ;; OB
      ;;
      ;; 5  2  1  2  1 ~
      ;;             5 EEEE                                    
      ;;             2               EE                              
      ;;             1                     E  E  EEE  E            
      ;;             2                         EEEEEEEEEEE    
      ;;             1                               EE  E    E  EE
      ;;                                     
      ;; 5  2  1  2  1 ~
      ;;             5 EEEE                                    
      ;;             2               EE                              
      ;;             1                     E  E                        
      ;;             2                         EEEEEEEEEEE    
      ;;             1                               EE  E    E  EE
      ;;                                     
      ;; 5  2  1  2  1 ~
      ;;             5 EEEE                                    
      ;;             2               EE                              
      ;;             1                     E  E                        
      ;;             2                         EEEEEEEE          
      ;;             1                               EE  E    E  EE
      ;;                                     
      ;; 5  2  1  2  1 ~
      ;;             5 EEEE                                    
      ;;             2               EE                              
      ;;             1                     E  E                        
      ;;             2                         EEEEEEEE          
      ;;             1                               EE  E    E      
      ;;                                     
      ;;
      ;; ČォB
      ;;
      ;; 5  2  1  2  1 ~
      ;;             5 EEEE                                    
      ;;             2               EE                              
      ;;             1                     E  E                        
      ;;             2                         EEEEEEEE          
      ;;             1                                           E      
      ;;                                     
      ;; 5  2  1  2  1 ~
      ;;             5 EEEE                                    
      ;;             2               EE                              
      ;;             1                     E  E                        
      ;;             2                                   EEE          
      ;;             1                                           E      
      ;;                                     
      ;; 5  2  1  2  1 ~
      ;;             5 EEEE                                    
      ;;             2               EE                              
      ;;             1                         E                        
      ;;             2                                   EEE          
      ;;             1                                           E      

      ;; O
      (do ((index 0 (1+ index))) ; indication O
  	  ((>= index indication-length))
	(setq one-indication (nth index line-indication))
	(setq len (nth 0 one-indication))
	(setq determination-cell-range (nth 1 one-indication))
	(setq potential-cell-ranges (nth 2 one-indication))
	(unless determination-cell-range ; m蕔܂Ȃ
	  (do ((i 0 (1+ i))) ; "..." ̕O
	      ((>= i on-range-info-length))
	    (setq one-on-range-info (nth i on-range-info))
	    (setq on-range (nth 0 one-on-range-info))
	    (setq potential-indexes (nth 2 one-on-range-info))
	    (when (= index (first potential-indexes)) ; "..." ܂މ\̂ index ̈ԑOȂ
	      (setq end-max (1- (+ (car on-range) len)))
	      (dolist (potential-cell-range potential-cell-ranges) ; \ "..." ܂ޔ͈͂ɋ߂
		(when (> (cdr potential-cell-range) end-max)
		  (setq return-update 1)
		  (setf (cdr potential-cell-range) end-max)))
	      (do ((j (1+ i) (1+ j))) ; c "..." ̕ index ܂܂Ȃ悤ɍXV
		  ((>= j on-range-info-length))
		(setq one-on-range-info (nth j on-range-info))
		(when (< end-max (car (nth 0 one-on-range-info)))
		  (delete index (nth 2 one-on-range-info))))))))
      ;; ォ
      (do ((index (1- indication-length) (1- index)))
	  ((< index 0))
	(setq one-indication (nth index line-indication))
	(setq len (nth 0 one-indication))
	(setq determination-cell-range (nth 1 one-indication))
	(setq potential-cell-ranges (nth 2 one-indication))
	(unless determination-cell-range ; m蕔܂Ȃ
	  (do ((i (1- on-range-info-length) (1- i)))
	      ((< i 0))
	    (setq one-on-range-info (nth i on-range-info))
	    (setq on-range (nth 0 one-on-range-info))
	    (setq potential-indexes (nth 2 one-on-range-info))
	    (when (= index (car (last potential-indexes)))
	      (setq begin-min (1+ (- (cdr on-range) len)))
	      (dolist (potential-cell-range potential-cell-ranges)
		(when (< (car potential-cell-range) begin-min)
		  (setq return-update 1)
		  (setf (car potential-cell-range) begin-min)))
	      (do ((j (1- i) (1- j)))
		  ((< j 0))
		(setq one-on-range-info (nth j on-range-info))
		(when (> begin-min (cdr (nth 0 one-on-range-info)))
		  (delete index (nth 2 one-on-range-info))))))))
      )
    
    return-update))


;;   nil
;; XV    1
;; XVȂ    0
(defun delete-potential-range (line-indication)
  (let ((return-update 0)
	len determination-cell-range
        potential-cell-ranges tmp-potential-cell-ranges
	line-indication-length)
    (dolist (one-indication line-indication)
      (setq len (nth 0 one-indication))
      (setq determination-cell-range (nth 1 one-indication))
      (setq potential-cell-ranges (nth 2 one-indication))
      ; \͈̔͂̏ꍇ
      (when (> (length potential-cell-ranges) 1)
	(setq tmp-potential-cell-ranges nil)
	(dolist (potential-cell-range potential-cell-ranges)
	  (cond
	   ; range  len Zꍇ폜
	   ((> len (length-range potential-cell-range))
	    (setq return-update 1))
	   ; m蕔Arange ɂ̕܂܂ĂȂꍇ폜
	   ((and determination-cell-range
		 (not (in-range determination-cell-range potential-cell-range)))
	    (setq return-update 1))
	   (t
	    (push potential-cell-range tmp-potential-cell-ranges))))
	(setf (nth 2 one-indication) (reverse tmp-potential-cell-ranges))
	))

    ;; `FbN
    ;; potential-cell-ranges  nil Ɩ
    (setq line-indication-length (length line-indication))
    (dotimes (i line-indication-length)
      (if (null (nth 2 (nth i line-indication)))
	  (return-from delete-potential-range nil)))
    
    return-update))


;;   nil
;; XV    1
;; XVȂ    0
(defun set-determination-range (line-indication line-simple-info)
  (let ((return-update 0)
	len begin-min end-max begin end width determination-cell-range
	potential-cell-ranges potential-cell-range)

    (setq width (length line-simple-info))
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; potential-cell-range ̏ꍇ len  potential-cell-range 
    ;; determination-cell-range g
    (dolist (one-indication line-indication)
      (setq len (nth 0 one-indication))
      (setq determination-cell-range (nth 1 one-indication))
      (setq potential-cell-ranges (nth 2 one-indication))
      (when (= 1 (length potential-cell-ranges))
	(setq potential-cell-range (car potential-cell-ranges))
	(setq begin-min (- (cdr potential-cell-range) (1- len)))
	(setq end-max (+ (car potential-cell-range) (1- len)))
	(if (null determination-cell-range)
	    (when (<= begin-min end-max)
	      (setq return-update 1)
	      (setf (nth 1 one-indication) (cons begin-min end-max)))
	  (progn
	    (when (< begin-min (car determination-cell-range))
	      (setq return-update 1)
	      (setf (car determination-cell-range) begin-min))
	    (when (> end-max (cdr determination-cell-range))
	      (setq return-update 1)
	      (setf (cdr determination-cell-range) end-max))))))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; determination-cell-range ɐڂĂ "" 
    ;; determination-cell-range g

    ;; mFĂȂ
    (dolist (one-indication line-indication)
      (setq determination-cell-range (nth 1 one-indication))
      (when determination-cell-range
	(setq begin (car determination-cell-range))
	(setq end (cdr determination-cell-range))
	(do ((i (1- begin) (1- i)))
	    ((or (< i 0)
		 (not (eq 1 (nth 0 (nth i line-simple-info)))))
	     (when (< (1+ i) begin)
	       (setq return-update 1)
	       (setf (car determination-cell-range) (1+ i))))
	  nil)
	(do ((i (1+ end) (1+ i)))
	    ((or (>= i width)
		 (not (eq 1 (nth 0 (nth i line-simple-info)))))
	     (when (> (1- i) end)
	       (setq return-update 1)
	       (setf (cdr determination-cell-range) (1- i))))
	  nil)))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;  "" ܂ potential-cell-ranges  index  1 Ȃ
    ;;  index  determination-cell-range ɐݒ
    (let (work-list indication-length one-indication
	  determination-cell-range)
      (setq indication-length (length line-indication))
      (dotimes (i width)
	(when (eq 1 (nth 0 (nth i line-simple-info)))
	  (setq work-list nil)
	  (dotimes (j indication-length)
	    (if (in-potential-cell-ranges i (nth j line-indication))
		(push j work-list)))
	  (when (= 1 (length work-list))
	    (setq determination-cell-range
		  (nth 1 (nth (car work-list) line-indication)))
	    (cond
	     ((null determination-cell-range)
	      (setf (nth 1 (nth (car work-list) line-indication)) (cons i i))
	      (setq return-update 1))
	     ((< i (car determination-cell-range))
	      (setf (car determination-cell-range) i)
	      (setq return-update 1))
	     ((< (cdr determination-cell-range) i)
	      (setf (cdr determination-cell-range) i)
	      (setq return-update 1))
	     )))))

    ;; `FbN
    (let ((range (cons 0 (1- width))))
      (dolist (one-indication line-indication)
	(setq determination-cell-range (nth 1 one-indication))
	(when determination-cell-range
	  (unless (in-range determination-cell-range range)
	    (return-from set-determination-range nil)))))
    
    return-update))


;;   nil
;; XV    1
;; XVȂ    0
(defun set-matrix-line (line-indication line-simple-info line-update-info)
  (let ((return-update 0)
	width begin end
	determination-cell-range potential-cell-ranges potential-cell-range
	cell-simple-info)

    (setq width (length line-simple-info))
    
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; determination-cell-range Ɋ܂܂͈͂ "" 
    (dolist (one-indication line-indication)
      (setq determination-cell-range (nth 1 one-indication))
      (when determination-cell-range
	(setq begin (car determination-cell-range))
	(setq end (cdr determination-cell-range))
	(do ((i begin (1+ i)))
	    ((> i end) nil)
	  (setq cell-simple-info (nth i line-simple-info))
	  (when (null (nth 0 cell-simple-info))
	    (setq return-update 1)
	    (setf (nth 0 cell-simple-info) 1)
	    (setf (nth 1 cell-simple-info) 0)
	    (setf (nth 2 cell-simple-info) t)
	    (setf (nth i line-update-info) t))
	  )))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; potential-cell-ranges Ɋ܂܂Ȃ͈͂ "~" 
    (dotimes (i width)
      (setq cell-simple-info (nth i line-simple-info))
      (if (null (nth 0 cell-simple-info))
	  (unless
	      (dolist (one-indication line-indication)
		(if (in-potential-cell-ranges i one-indication)
		    (return t))
		nil)
	    (setq return-update 1)
	    (setf (nth 0 cell-simple-info) 0)
	    (setf (nth 1 cell-simple-info) 0)
	    (setf (nth 2 cell-simple-info) t)
	    (setf (nth i line-update-info) t))))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; A ""  range Ƃ܂މ\̂ index ̃Xg̎擾
    (let (on-range-info on-range range-stop potential-indexes
  	  on-range-begin on-range-end
	  max-length min-length shortage-length)
      (setq on-range-info (get-on-range-info line-indication line-simple-info))
      (if (error-on-range-exist-p on-range-info)
	  (return-from set-matrix-line nil))

      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;; A ""  potential-cell-ranges Ɋ܂ one-indication ̒ł
      ;; Œ length  "" ̘AĂ鐔Ȃ
      ;; A "" ̗[ "~" 
      (dolist (one-on-range-info on-range-info)
	(setq on-range (nth 0 one-on-range-info))
	(setq range-stop (nth 1 one-on-range-info))
	(setq potential-indexes (nth 2 one-on-range-info))
	(setq max-length
	      (apply #'max
		     (mapcar #'(lambda (index)
				 (nth 0 (nth index line-indication)))
			     potential-indexes)))
	(when (= (length-range on-range) max-length)
	  (setq on-range-begin (car on-range))
	  (setq on-range-end (cdr on-range))
	  ; on-range ̈O "~" 
	  (when (<= 0 (1- on-range-begin))
	    (setq cell-simple-info (nth (1- on-range-begin) line-simple-info))
	    (when (null (nth 0 cell-simple-info))
	      (setq return-update 1)
	      (setf (nth 0 cell-simple-info) 0)
	      (setf (nth 1 cell-simple-info) 0)
	      (setf (nth 2 cell-simple-info) t)
	      (setf (nth (1- on-range-begin) line-update-info) t)))
	  ; on-range ̈ "~" 
	  (when (> width (1+ on-range-end))
	    (setq cell-simple-info (nth (1+ on-range-end) line-simple-info))
	    (when (null (nth 0 cell-simple-info))
	      (setq return-update 1)
	      (setf (nth 0 cell-simple-info) 0)
	      (setf (nth 1 cell-simple-info) 0)
	      (setf (nth 2 cell-simple-info) t)
	      (setf (nth (1+ on-range-end) line-update-info) t)))
	  ))

      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;; "~..." or "...~" ̏ꍇ
      ;; A ""  potential-cell-ranges Ɋ܂ one-indication ̒ł
      ;; ŒZ length ƂȂ܂ "..." 
      (dolist (one-on-range-info on-range-info)
	(setq on-range (nth 0 one-on-range-info))
	(setq range-stop (nth 1 one-on-range-info))
	(setq potential-indexes (nth 2 one-on-range-info))
	(when (or (and (car range-stop) (not (cdr range-stop)))
		  (and (not (car range-stop)) (cdr range-stop)))
	  (setq min-length
		(apply #'min
		       (mapcar #'(lambda (index)
				   (nth 0 (nth index line-indication)))
			       potential-indexes)))
	  (setq shortage-length	(- min-length (length-range on-range)))
	  (when (plusp shortage-length)
	    (setq on-range-begin (car on-range))
	    (setq on-range-end (cdr on-range))
 	    (cond
 	     ; "~..."
 	     ((and (car range-stop) (not (cdr range-stop)))
  	      (do ((i (1+ on-range-end) (1+ i)))
  		  ((> i (+ on-range-end shortage-length)))
  		(setq cell-simple-info (nth i line-simple-info))
  		(when (null (nth 0 cell-simple-info))
  		  (setq return-update 1)
  		  (setf (nth 0 cell-simple-info) 1)
  		  (setf (nth 1 cell-simple-info) 0)
  		  (setf (nth 2 cell-simple-info) t)
  		  (setf (nth i line-update-info) t)))
 	      )
 	     ; "...~"
	     ((and (not (car range-stop)) (cdr range-stop))
  	      (do ((i (1- on-range-begin) (1- i)))
  		  ((< i (- on-range-begin shortage-length)))
  		(setq cell-simple-info (nth i line-simple-info))
  		(when (null (nth 0 cell-simple-info))
  		  (setq return-update 1)
  		  (setf (nth 0 cell-simple-info) 1)
  		  (setf (nth 1 cell-simple-info) 0)
  		  (setf (nth 2 cell-simple-info) t)
  		  (setf (nth i line-update-info) t))))))))

      )
    
    return-update))

;; ǂ index ɂȂ on-range ꍇȂ̂ t
(defun error-on-range-exist-p (on-range-info)
  (dolist (one-on-range-info on-range-info)
    (if (null (nth 2 one-on-range-info))
	(return-from error-on-range-exist-p t)))
  nil)


;; ((on-range range-stop potential-indexes)*)
;(defun get-on-range-and-potential-indexes-list (line-indication line-simple-info))
(defun get-on-range-info (line-indication line-simple-info)
  (let ((return-list nil)
	width begin end begin-stop-p end-stop-p indication-length
	index-list
	cell-simple-info)
    (setq width (length line-simple-info))
    (setq indication-length (length line-indication))
    
    (setq begin-stop-p t)
    (do ((i 0 (1+ i)))
	((>= i width) nil)
      (case (nth 0 (nth i line-simple-info))
	((0)   ; "~"
	 (setq begin-stop-p t))
	((nil) ; ""
	 (setq begin-stop-p nil))
	((1)   ; ""
	 (setq begin i)
	 (setq end-stop-p nil)
	 (do ((j (1+ i) (1+ j)))
	     ((or (>= j width)
		  (not (eq 1 (nth 0 (nth j line-simple-info))))) ; "" ȊO
	      (setq end (1- j))
	      (if (or (>= j width)
		      (eq 0 (nth 0 (nth j line-simple-info))))
		  (setq end-stop-p t)))
	   nil)
	 (setq index-list '())
	 (dotimes (j indication-length)
	   (if (in-potential-cell-ranges (cons begin end)
					 (nth j line-indication))
	       (push j index-list)))
	 (push (list (cons begin end) (cons begin-stop-p end-stop-p) (reverse index-list)) return-list)
	 (setq i end))))
    (reverse return-list)))

(defun length-range (range)
  (if range
      (1+ (- (cdr range) (car range)))
    0))

(defun in-potential-cell-ranges (position_or_range one-indication)
  (let (range)
    (dolist (potential-cell-range (nth 2 one-indication))
      (if (setq range (in-range position_or_range potential-cell-range))
	  (return-from in-potential-cell-ranges range))))
  nil)

(defun in-determination-cell-range (position_or_range one-indication)
  (in-range position_or_range (nth 1 one-indication)))

(defun in-range (position_or_range range)
  (if (null range)
      nil
    (cond
     ((numberp position_or_range)
      (if (and (<= (car range) position_or_range)
	       (<= position_or_range (cdr range)))
	  range
	nil))
     ((consp position_or_range)
      (if (and (<= (car range) (car position_or_range))
	       (<= (cdr position_or_range) (cdr range)))
	  range
	nil))
     (t nil))))


(defun rotate-cell-update (line-simple-info)
  (dolist (cell-simple-info line-simple-info)
    (case (nth 1 cell-simple-info)
      ((1) (setf (nth 1 cell-simple-info) nil))
      ((0) (setf (nth 1 cell-simple-info) 1)))))

(defun priority-consideration-sort-undecided-cell-list (cell-list pre-checked-cell-list)
  (let (pre-update-cell
	pre-update-cell-row pre-update-cell-col
	pre-update-cell-row-plus pre-update-cell-row-minus
	pre-update-cell-col-plus pre-update-cell-col-minus
	row col hit pre-checked
	side round1 round2
        space0 space1 space2 space3 space4
	pre-checked-space0 pre-checked-space1 pre-checked-space2
	pre-checked-space3 pre-checked-space4)

    (when pre-checked-cell-list
      (setq pre-update-cell (car pre-checked-cell-list))
      (setq pre-update-cell-row (car pre-update-cell))
      (setq pre-update-cell-col (cdr pre-update-cell))
      (setq pre-update-cell-row-plus (1+ pre-update-cell-row))
      (setq pre-update-cell-row-minus (1- pre-update-cell-row))
      (setq pre-update-cell-col-plus (1+ pre-update-cell-col))
      (setq pre-update-cell-col-minus (1- pre-update-cell-col)))

    (dolist (cell (reverse cell-list))
      (setq hit 0)
      (setq pre-checked nil)
      (setq row (car cell))
      (setq col (cdr cell))
      (cond
       ((and pre-update-cell
	       (or (and (= row pre-update-cell-row)
			(or (= col pre-update-cell-col-plus)
			    (= col pre-update-cell-col-minus)))
		   (and (= col pre-update-cell-col)
			(or (= row pre-update-cell-row-plus)
			    (= row pre-update-cell-row-minus)))))
	(setq hit 'side))
       ((and pre-update-cell
	     (or (and (= row pre-update-cell-row-minus)
		      (or (= col pre-update-cell-col-minus)
			  (= col pre-update-cell-col-plus)))
		 (and (= row pre-update-cell-row-plus)
		      (or (= col pre-update-cell-col-minus)
			  (= col pre-update-cell-col-plus)))))
	(setq hit 'round1))
       ((and pre-update-cell
	       (or (and (= row pre-update-cell-row)
			(or (= col (+ pre-update-cell-col 2))
			    (= col (- pre-update-cell-col 2))))
		   (and (= col pre-update-cell-col)
			(or (= row (+ pre-update-cell-row 2))
			    (= row (- pre-update-cell-row 2))))))
	(setq hit 'round2))
       (t
	(if (find (cons row col) pre-checked-cell-list :test #'equal)
	    (setq pre-checked t))
	(if (find (cons (1- row) col) cell-list :test #'equal)
	    (incf hit))
	(if (find (cons (1+ row) col) cell-list :test #'equal)
	    (incf hit))
	(if (find (cons row (1- col)) cell-list :test #'equal)
	    (incf hit))
	(if (find (cons row (1+ col)) cell-list :test #'equal)
	    (incf hit))))
      
      (if pre-checked
	  (case hit
	    (0 (push cell pre-checked-space0))
	    (1 (push cell pre-checked-space1))
	    (2 (push cell pre-checked-space2))
	    (3 (push cell pre-checked-space3))
	    (4 (push cell pre-checked-space4)))
	(case hit
	  ('side (push cell side))
	  ('round1 (push cell round1))
	  ('round2 (push cell round2))
	  (0 (push cell space0))
	  (1 (push cell space1))
	  (2 (push cell space2))
	  (3 (push cell space3))
	  (4 (push cell space4))))
      )
    
    (if pre-update-cell
	(labels ((square (x) (* x x))
		 (distance (cell)
		   (+ (square (- (car cell) (car pre-update-cell)))
		      (square (- (cdr cell) (cdr pre-update-cell))))))
	  (setq side (stable-sort side #'< :key #'distance))
	  (setq round1 (stable-sort round1 #'< :key #'distance))
	  (setq round2 (stable-sort round2 #'< :key #'distance))
	  (setq space0 (stable-sort space0 #'< :key #'distance))
	  (setq space1 (stable-sort space1 #'< :key #'distance))
	  (setq space2 (stable-sort space2 #'< :key #'distance))
	  (setq space3 (stable-sort space3 #'< :key #'distance))
	  (setq space4 (stable-sort space4 #'< :key #'distance))
	  (setq pre-checked-space0 (stable-sort pre-checked-space0 #'< :key #'distance))
	  (setq pre-checked-space1 (stable-sort pre-checked-space1 #'< :key #'distance))
	  (setq pre-checked-space2 (stable-sort pre-checked-space2 #'< :key #'distance))
	  (setq pre-checked-space3 (stable-sort pre-checked-space3 #'< :key #'distance))
	  (setq pre-checked-space4 (stable-sort pre-checked-space4 #'< :key #'distance))))

    (append side round1 round2 space0 space1 space2 space3 space4
	    pre-checked-space0 pre-checked-space1 pre-checked-space2 pre-checked-space3 pre-checked-space4)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get-input-height (input-or-indication)
  (length (car input-or-indication)))
(defun get-input-width (input-or-indication)
  (length (cadr input-or-indication)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun make-indication (input)
  (let (left-indication upper-indication
        left-input upper-input height width)
    (setq left-indication nil)
    (setq upper-indication nil)
    (setq left-input (car input))
    (setq upper-input (cadr input))
    (setq height (length left-input))
    (setq width (length upper-input))
    
    (dolist (line-input (reverse left-input))
      (if (null line-input)
	  (push nil left-indication)
	(push (mapcar #'(lambda (len)
			  (list len nil (list (cons 0 (1- width))))) line-input)
	      left-indication)))
    (dolist (line-input (reverse upper-input))
      (if (null line-input)
	  (push nil upper-indication)
	(push (mapcar #'(lambda (len)
			  (list len nil (list (cons 0 (1- height))))) line-input)
	      upper-indication)))
    (list left-indication upper-indication)))

(defun make-undecided-cell-list (matrix-simple-info)
  (let (row-simple-info
	col-simple-info
	height width
	undecided-cell-list)
    (setq row-simple-info (car matrix-simple-info))
    (setq col-simple-info (cadr matrix-simple-info))
    (setq height (length row-simple-info))
    (setq width (length col-simple-info))

    (dotimes (i height)
      (dotimes (j width)
	(unless (nth 0 (nth j (nth i row-simple-info)))
	  (push (cons i j) undecided-cell-list))))
    (reverse undecided-cell-list)))

(defun make-update-info (input &optional (init-value t))
  (let (row-update-info col-update-info height width)
    (setq row-update-info nil)
    (setq col-update-info nil)
    (setq height (length (car input)))
    (setq width (length (cadr input)))
    
    (dotimes (i height)
      (push init-value row-update-info))
    (dotimes (i width)
      (push init-value col-update-info))
    (list row-update-info col-update-info)))

(defun make-matrix-simple-info (input)
  (let (row-simple-info reverse-col-simple-info height width
	default-line-simple-info)
    (setq row-simple-info nil)
    (setq reverse-col-simple-info nil)
    (setq height (length (car input)))
    (setq width (length (cadr input)))

    ;; row-simple-info ̍쐬
    (setq default-line-simple-info nil)
    (dotimes (i width)
      (push '(nil nil nil) default-line-simple-info))
    (dotimes (i height)
      (push (copy-tree default-line-simple-info) row-simple-info))
    ;; col-simple-info ̐ (row-simple-info ̃|C^tւ)
    (dotimes (i width)
      (push
       (mapcar #'(lambda (hline-simple-info)
		   (nth i hline-simple-info)) row-simple-info)
       reverse-col-simple-info))
    ;;
    (list row-simple-info (reverse reverse-col-simple-info))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun copy-indication (indication)
  (copy-tree indication))

(defun copy-matrix-simple-info (matrix-simple-info)
  (let (row-simple-info
	height width
	new-row-simple-info
	new-reverse-col-simple-info)
    (setq width (length (nth 1 matrix-simple-info)))
    (setq row-simple-info (car matrix-simple-info))
    (setq new-row-simple-info (copy-tree row-simple-info))
    (dotimes (i width)
      (push
       (mapcar #'(lambda (hline-simple-info)
		   (nth i hline-simple-info)) new-row-simple-info)
       new-reverse-col-simple-info))
    (list new-row-simple-info (reverse new-reverse-col-simple-info))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; cell := (row . col)
(defun set-cell-simple-info (matrix-simple-info cell cell-simple-info)
  (let ((i (car cell))
	(j (cdr cell)))
    (setf (nth j (nth i (car matrix-simple-info))) cell-simple-info)
    (setf (nth i (nth j (cadr matrix-simple-info))) cell-simple-info)))

(defun set-cell-update-info (update-info cell)
  (setf (nth (car cell) (car update-info)) t)
  (setf (nth (cdr cell) (cadr update-info)) t))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; attribute
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun set-cell-list-attribute (tag cell-list indication matrix-only)
  (save-excursion
    (let (base-point)
      (goto-matrix-base-point indication matrix-only)
      (setq base-point (point))
      (dolist (cell cell-list)
	(goto-char base-point)
	(next-line (car cell))
	(forward-char (cdr cell))
	(apply #'set-text-attribute (point) (1+ (point)) tag
	       (cdr (assoc tag *ilogic-attribute-alist*))))
      
      )))

(defun unset-cell-list-attribute (check-tag cell-list indication matrix-only)
  (save-excursion
    (let (base-point)
      (goto-matrix-base-point indication matrix-only)
      (setq base-point (point))
      (dolist (cell cell-list)
	(goto-char base-point)
	(next-line (car cell))
	(forward-char (cdr cell))
	(multiple-value-bind (start end tag)
	    (find-text-attribute-point (point))
	  (when (eq tag check-tag)
	    (delete-text-attribute-point (point)))))
      )))

(defun get-cell-list-attribute (tag indication matrix-only)
  (save-excursion
    (let (base-point
	  base-line-number base-column
	  opoint point-list cell-list)
      (goto-matrix-base-point indication matrix-only)
      (setq base-point (point))
      (setq base-line-number (current-line-number))
      (setq base-column (current-column))
      (setq opoint -1)
      (while (setq opoint (find-text-attribute tag :start (1+ opoint)))
	(push opoint point-list))
      (while point-list
	(goto-char (pop point-list))
	(push (cons (- (current-line-number) base-line-number)
		    (/ (- (current-column) base-column) 2))
	      cell-list))

      cell-list)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; o
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun print-matrix-base (indication matrix-simple-info &optional (matrix-only nil))
  (save-excursion
    (let (left-indication upper-indication width height
	  hindex-len vindex-len hline-str-len
	  row-simple-info
	  matrix-begin-point)
      (setq left-indication (car indication))
      (setq upper-indication (cadr indication))
      (setq height (length left-indication))
      (setq width (length upper-indication))
      (setq row-simple-info (car matrix-simple-info))

      (setq hline-str-len 0)
      (setq matrix-begin-point (point))

      ;; INDICATION ̏o
      (unless matrix-only
	(setq hindex-len (apply #'max (mapcar #'length left-indication)))
	(setq vindex-len (apply #'max (mapcar #'length upper-indication)))
	(setq hline-str-len (+ (* 2 hindex-len) hindex-len))

	; UPPER_INDICATION ̏o
	(dotimes (i vindex-len)
	  (insert " " hline-str-len)
	  (dolist (vline-indication upper-indication)
	    (if (> vindex-len (+ i (length vline-indication)))
		(insert "  ")
	      (insert
	       (format nil "~2D"
		       (car (nth (- i (- vindex-len (length vline-indication)))
				 vline-indication)))))
	    )
	  (insert "  \n")
	  )

	(setq matrix-begin-point (+ (point) hline-str-len))

	; LEFT_INDICATION ̏o
	(let (control-string)
	  (setq control-string (concat "~" (format nil "~D" hline-str-len) "A"))
	  (dolist (hline-indication left-indication)
	    (if (null hline-indication)
		(insert " " hline-str-len)
	      (insert
	       (format nil control-string
		       (format nil "~{~2D ~}"
			       (mapcar #'car hline-indication)))))
	    (insert "\n")
	    ))
	)
      
      ;; MATRIX ̏o
      (let (row-num col-num matrix-bol-point cell-simple-info)
	(goto-char matrix-begin-point)
	(dotimes (i height)
	  (setq row-num (1+ i))
	  (setq matrix-bol-point (point))
	  (dotimes (j width)
	    (setq cell-simple-info (nth j (nth i row-simple-info)))
	    (insert
	     (case (car cell-simple-info)
	       ((nil) "")
	       ((1)   "")
	       ((0)   "~")
	       (t     "H"))))
	  (insert
	   (if (zerop (mod row-num 5))
	       (format nil "~2D" row-num)
	     "  "))
	  (if matrix-only (insert "\n"))
	  (goto-char matrix-bol-point)
	  (next-line))
	(insert " " hline-str-len)
	(dotimes (i width)
	  (setq col-num (1+ i))
	  (insert
	   (if (zerop (mod col-num 5))
	       (format nil "~2D" col-num)
	     "  ")))
	(insert "  \n"))
      (insert "\n")
      )))


(defun overwrite-row-line (row-num row-simple-info indication supposition-level
			&optional (matrix-only nil) (interval-time nil))
  (save-excursion
    (let (left-indication upper-indication height width
	  hindex-len vindex-len hline-str-len
	  line-simple-info cell-simple-info
	  new-point-list
	  point-attribute-list)
      (setq left-indication (car indication))
      (setq upper-indication (cadr indication))
      (setq height (length left-indication))
      (setq width (length upper-indication))
      (setq line-simple-info (nth (1- row-num) row-simple-info))
      
      ;; INDICATION
      (unless matrix-only
	(setq hindex-len (apply #'max (mapcar #'length left-indication)))
	(setq vindex-len (apply #'max (mapcar #'length upper-indication)))
	(setq hline-str-len (+ (* 2 hindex-len) hindex-len))

	(forward-char hline-str-len)
	(next-line vindex-len)
	)

      (next-line (1- row-num))
      (dotimes (i width)
	(setq cell-simple-info (nth i line-simple-info))
	(when (nth 2 cell-simple-info)
	  (setf (nth 2 cell-simple-info) nil)
	  (insert
	   (case (car cell-simple-info)
	     ((nil) "")
	     (1     "")
	     (0     "~")
	     (t     "H")))
	  (delete-char)
	  (backward-char)
	  (multiple-value-bind (start end tag)
	      (find-text-attribute-point (point))
	    (when start
	      (push (list start end tag) point-attribute-list)))
	  (apply #'set-text-attribute (point) (1+ (point)) 'new
		 (cdr (assoc 'new *ilogic-attribute-alist*)))
	  (push (point) new-point-list)
	  )
	(forward-char))
      (delete-char 2)
      (insert "")
      (backward-char)
      (refresh-screen)
      (if interval-time (sleep-for interval-time))
      (delete-char)
      (insert
       (if (zerop (mod row-num 5))
	   (format nil "~2D" row-num)
	 "  "))
      (delete-text-attributes 'new)

      (when (plusp supposition-level)
	(dolist (new-point new-point-list)
	  (apply #'set-text-attribute new-point (1+ new-point)
		 'supposition
		 (cdr (assoc 'supposition *ilogic-attribute-alist*)))))

      (dolist (point-attribute point-attribute-list)
	(apply #'set-text-attribute
	       (first point-attribute)
	       (second point-attribute)
	       (third point-attribute)
	       (cdr (assoc (third point-attribute) *ilogic-attribute-alist*))))
      )))

(defun overwrite-col-line (col-num col-simple-info indication supposition-level
			&optional (matrix-only nil) (interval-time nil))
  (save-excursion
    (let (left-indication upper-indication height width
	  hindex-len vindex-len hline-str-len
          line-simple-info cell-simple-info
	  new-point-list
	  point-attribute-list)
      (setq left-indication (car indication))
      (setq upper-indication (cadr indication))
      (setq height (length left-indication))
      (setq width (length upper-indication))
      (setq line-simple-info (nth (1- col-num) col-simple-info))

      ;; INDICATION
      (unless matrix-only
	(setq hindex-len (apply #'max (mapcar #'length left-indication)))
	(setq vindex-len (apply #'max (mapcar #'length upper-indication)))
	(setq hline-str-len (+ (* 2 hindex-len) hindex-len))

	(forward-char hline-str-len)
	(next-line vindex-len)
	)

      (forward-char (1- col-num))
      (dotimes (i height)
	(setq cell-simple-info (nth i line-simple-info))
	(when (nth 2 cell-simple-info)
	  (setf (nth 2 cell-simple-info) nil)
	  (insert
	   (case (car cell-simple-info)
	     ((nil) "")
	     (1     "")
	     (0     "~")
	     (t     "H")))
	  (delete-char)
	  (backward-char)
	  (multiple-value-bind (start end tag)
	      (find-text-attribute-point (point))
	    (when start
	      (push (list start end tag) point-attribute-list)))
	  (apply #'set-text-attribute (point) (1+ (point)) 'new
		 (cdr (assoc 'new *ilogic-attribute-alist*)))
	  (push (point) new-point-list)
	  )
	(next-line))
      (delete-char 2)
      (insert "")
      (backward-char)
      (refresh-screen)
      (if interval-time (sleep-for interval-time))
      (delete-char)
      (insert
       (if (zerop (mod col-num 5))
	   (format nil "~2D" col-num)
	 "  "))
      (delete-text-attributes 'new)

      (when (plusp supposition-level)
	(dolist (new-point new-point-list)
	  (apply #'set-text-attribute new-point (1+ new-point)
		 'supposition
		 (cdr (assoc 'supposition *ilogic-attribute-alist*)))))

      (dolist (point-attribute point-attribute-list)
	(apply #'set-text-attribute
	       (first point-attribute)
	       (second point-attribute)
	       (third point-attribute)
	       (cdr (assoc (third point-attribute) *ilogic-attribute-alist*))))
      )))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ړ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun goto-matrix-base-point (indication matrix-only)
  (let (left-indication upper-indication height width
	hindex-len vindex-len hine-str-len)
    (setq left-indication (car indication))
    (setq upper-indication (cadr indication))
    (setq height (length left-indication))
    (setq width (length upper-indication))

    (unless matrix-only
      (setq hindex-len (apply #'max (mapcar #'length left-indication)))
      (setq vindex-len (apply #'max (mapcar #'length upper-indication)))
      (setq hline-str-len (+ (* 2 hindex-len) hindex-len))

      (forward-char hline-str-len)
      (next-line vindex-len))
    ))

(defun clean-supposition-matrix (cell-list indication matrix-only)
  (save-excursion
    (let (left-indication upper-indication height width
	  hindex-len vindex-len hine-str-len
	  start-point)
      (setq left-indication (car indication))
      (setq upper-indication (cadr indication))
      (setq height (length left-indication))
      (setq width (length upper-indication))

      (unless matrix-only
	(setq hindex-len (apply #'max (mapcar #'length left-indication)))
	(setq vindex-len (apply #'max (mapcar #'length upper-indication)))
	(setq hline-str-len (+ (* 2 hindex-len) hindex-len))

	(forward-char hline-str-len)
	(next-line vindex-len)
	)
      (setq start-point (point))
      (dolist (cell cell-list)
	(next-line (car cell))
	(forward-char (cdr cell))
	(multiple-value-bind (start end tag)
	    (find-text-attribute-point (point))
	  (when (eq tag 'supposition)
	    (delete-text-attribute-point (point))))

	(insert "")
	(delete-char)
;	(backward-char)
;	(refresh-screen)
	(goto-char start-point))
      )))


      
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ⏕
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun assistant-info-string (line-indication line-simple-info)
  (let (index-len width line-str-len return-str control-string tmp-list)
    (setq index-len (length line-indication))
    (setq width (length line-simple-info))
    
    (setq return-str (format nil "~{~2D ~}" (mapcar #'car line-indication)))
    (setq line-str-len (length return-str))
    (setq return-str
	  (concat return-str
		  (apply 'concat
			 (mapcar #'(lambda (cell-simple-info)
				     (case (car cell-simple-info)
				       ((1) "")
				       ((0) "~")
				       ((nil) "")))
				 line-simple-info)) "\n"))

    (setq control-string (concat "~" (format nil "~D" line-str-len) "A"))
    (dolist (one-indication line-indication)
      (setq tmp-list nil)
      (push (format nil control-string
		    (format nil "~2D " (car one-indication)))
	    tmp-list)

      (dotimes (i width)
	(push (cond
	       ((in-determination-cell-range i one-indication) "")
	       ((in-potential-cell-ranges i one-indication) "E")
	       (t "  "))
	      tmp-list))
      (setq return-str
	    (concat return-str
		    (apply #'concat (reverse tmp-list)) "\n"))
      )
    return-str))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; data structure
#|

INFO
MATRIX     : s
ROW        : s
COL        : 
CELL       : Z

NUM        : ԍ
  ROW_NUM    : sԍ
  COL_NUM    : ԍ

;;----------------------------------------------------------------------
{^
<number> : /[1-9][0-9]*/

<BEGIN>  : <number>
<END>    : <number>

<LENGTH> : <number>


;;----------------------------------------------------------------------
̓f[^

<INPUT>       : (<LEFT_INPUT> <UPPER_INPUT>)

<LEFT_INPUT>  : (<LINE_INPUT>+) ; height JԂ
<UPPER_INPUT> : (<LINE_INPUT>+) ; width JԂ

<LINE_INPUT>  : nil
              | (<LENGTH>+)


;;----------------------------------------------------------------------
wf[^

<INDICATION>               : (<LEFT_INDICATION> <UPPER_INDICATION>)

<LEFT_INDICATION>          : (<LINE_INDICATION>+)  ; height JԂ
<UPPER_INDICATION>         : (<LINE_INDICATION>+)  ; width JԂ

<LINE_INDICATION>          : nil                   ; line ɁȂ
                           | (<ONE_INDICATION>+)   ; ŏPʂ indication Ɋւ

<ONE_INDICATION>           : (<LENGTH> <DETERMINATION_CELL_RANGE> <POTENTIAL_CELL_RANGES>)

<DETERMINATION_CELL_RANGE> : nil               ; 
                           | (<BEGIN> . <END>) ; matrix Ŋm肵Ă cell ͈̔

<POTENTIAL_CELL_RANGES>    : (<POTENTIAL_CELL_RANGE>+) ; matrix ŉ\̎cĂ
                                                       ; cell ͈̔

<POTENTIAL_CELL_RANGE>     : (<BEGIN> . <END>)



;;----------------------------------------------------------------------
sXV

<UPDATE_INFO>      : (<ROW_UPDATE_INFO> <COL_UPDATE_INFO>)

<ROW_UPDATE_INFO>  : <LINE_UPDATE_INFO> ; height JԂ
<COL_UPDATE_INFO>  : <LINE_UPDATE_INFO> ; width JԂ

<LINE_UPDATE_INFO> : (<line_update>+)

<line_update>      : nil        ; XVȂ
                   | t          ; XV


;;----------------------------------------------------------------------
sP̏ [c֌WACELL ݂̂ŕĂ]
##  <ROW_SIMPLE_INFO>  <COL_SIMPLE_INFO> ͓̈قȂr[
##  Vꍇ <CELL_SIMPLE_INFO> ɒǉ

<MATRIX_SIMPLE_INFO> : (<ROW_SIMPLE_INFO> <COL_SIMPLE_INFO>)

<ROW_SIMPLE_INFO>    : (<LINE_SIMPLE_INFO>+) ; height JԂ [s]
<COL_SIMPLE_INFO>    : (<LINE_SIMPLE_INFO>+) ; width JԂ  [񁨍s]

<LINE_SIMPLE_INFO>   : (<CELL_SIMPLE_INFO>+) ; c葤(height or width) JԂ

<CELL_SIMPLE_INFO>   : (<output> <update> <print>)

<output>             : nil       ; s()
                     | 0         ; OFF m(~)
                     | 1         ; ON  m()
<update>             : 0         ; ݂̃`FbNōXV
                     | 1         ; XV
                     | nil       ; XVȂ

<print>              : t         ; <output> ̕ύX܂o͂ĂȂ
                     | nil       ; Ȍo͂疢ύX


;;----------------------------------------------------------------------


|#


